% (c) Mario Hlawitschka 2010
% script to calculate the FNM for a given input field stored in
% fig3_pressure

%crop=true
%mode = 'Hu'
%mode = 'hu'
%mode = 'huC++'
%mode = 'HuC++'
%restriction = 'n'
%restriction = 'a'   % somehow, the filter is too much a low-pass, has to be checked!

%D = 0.09; %0.1531; % 15cm so we have 512^2
%D=0.27
D=0.18

f0=1e6;

define_media;

a = size(fig3_pressure,1);
width = 0.09; % 9cm
halfwidth = width/2;
delta = width/a;

Nn=uint32(floor(D/delta));
N = double(Nn)


lambda = lossless.soundspeed/f0;
k=2*pi/lambda;



figure(1)
x=-halfwidth:delta:halfwidth-delta;
y=-halfwidth:delta:halfwidth-delta;
x=x*100;
y=y*100;
%y=0:.1:30-.1;
mesh(y,x,(abs(fig3_pressure)));
view(-68,62);
axis tight;
ylabel('x(cm)');
xlabel('y(cm)');
zlabel('Normalized pressure');
title('original input (FNM)')




plane = zeros(N,N);

%plane(D/2-a+1:D/2+a,D/2-a+1:D/2+a) = fig3_pressure(:,:);
plane(floor(N/2+1-a/2):floor(N/2+a/2),floor(N/2+1-a/2):floor(N/2+a/2)) = fig3_pressure(:,:);


figure(2)
x=-halfwidth*N/a:delta:halfwidth*N/a-delta;
y=-halfwidth*N/a:delta:halfwidth*N/a-delta;
%y=0:.1:30-.1;
x=x*100;
y=y*100;
mesh(y,x,(abs(plane)));
view(-68,62);
axis tight;
title( 'padded input' );
ylabel('x(cm)');
xlabel('y(cm)');
zlabel('Normalized pressure');


dz = 1e-3;
blocks = 3; % was 300, but that is too big for my memory, so split it in blocks
layers = 300;


%plane = fft2(plane);
tic
field = zeros(N, N, layers);
for i=1:blocks
    tmp_field = MLAngularSpectrumApproach( plane, [N, N, layers/blocks], [delta delta dz], k, dz*layers/blocks*(i-1), 'Pa', 10);
    field(:,:,layers/blocks*(i-1)+1:layers/blocks*i) = tmp_field;
end
toc

mlout = squeeze(field(:,floor(N/2),:));

figure(3)
z=0:dz:dz*layers-dz;
mesh(z,x,abs(mlout)); axis tight;

figure(4)
%surf(abs(debugdata))
imagesc(abs(mlout)); axis tight;
