% script to generate the image from figure 2
% known conditions:
% Transducer: rectangle, 3cmx3cm at origin
% Pressure Grid is x-z plane, x from -4.5 to 4.5cm, z from 0 to 30cm
% f0=1e6, losses, nonattenuating medium
% Result is normalized, 
f0=1e6;

define_media;
Transducer=get_rect(.015,.015,[0 0 0],[0 0 0]);
ps=set_coordinate_grid(.001,-.045,.045,0,0,0,.3);
fig2_pressure=squeeze(gpu_fnm_call(Transducer,ps,lossless,100,f0,0));
fig2_pressure=fig2_pressure./max(max(fig2_pressure));
%trimming pressure field to make it look better
fig2_pressure=fig2_pressure(1:90,1:300);
x=-4.5:9/90:4.5-9/90;
y=0:.1:30-.1;
mesh(y,x,(abs(fig2_pressure)));
view(-68,62);
axis tight;
ylabel('x(cm)');
xlabel('z(cm)');
zlabel('Normalized pressure');