% script to generate the image from figure 2
% known conditions:
% Transducer: rectangle, 3cmx3cm at origin
% Pressure Grid is x-z plane, x from -4.5 to 4.5cm, z from 0 to 30cm
% f0=1e6, losses, nonattenuating medium
% Result is normalized, 
f0=1e6;
%tissue_gen;
define_media;
Transducer=get_rect(.015,.015,[0 0 0],[0 0 0]);
%Transducer=get_circ(.015,[0 0 0],[0 0 0]);
ps=set_coordinate_grid(.001,-.03,.03,0,0,0,.3);
fig6_pressure=squeeze(gpu_fnm_call(Transducer,ps,attenuated,80,f0,0));
%fig6_pressure=squeeze(rayleigh(Transducer,ps,attenuated,80,f0,0));
fig6_pressure=fig6_pressure./max(max(fig6_pressure));
%trimming pressure field to make it look better
fig6_pressure=fig6_pressure(1:60,1:300);
x=-3:6/60:3-6/60;
y=0:.1:30-.1;
mesh(y,x,(abs(fig6_pressure)));
view(-68,62);
ylabel('x(cm)');
xlabel('z(cm)');
zlabel('Normalized pressure');
