%mex /Users/mario/Uni/BioEng/Code/matlab_src/MLRectilinearArray.cpp -I/Users/mario/Uni/BioEng/Code/ -I/Users/mario/Uni/BioEng/Code/src/ -I/Users/mario/Uni/FAnToM/FAnToM/ /Users/mario/Uni/BioEng/Code/build/lib/libFastNearfieldCuda.a  /usr/local/cuda/lib/libcuda.dylib /usr/local/cuda/lib/libcudart.dylib

N = 128;
iso= 0.1;
iso2= 0.6;

array = [10, 10];
arrayspacing = [2., 2.];

gridspacing = [0.25, 0.25, 0.5];
focus = [ 0.5*(arrayspacing(1) * (array(1)-1)) ...
          0.5*(arrayspacing(2) * (array(2)-1)) ...
          20.]; % place focus in the center of the array

if false
    out = MLRectilinearArray( ...
        [N,N,N], ...                    dimensions
        gridspacing, ...                resolution/cell size
        focus, ...                      focus point (z<-0.5 => no focus)
        array(1),array(2), ...          array size (x,y)
        arrayspacing(1), arrayspacing(2), ...              array distance x,y direction
        1.,1.,2.);                      % (x-length), s (y-length), k (wavenumber) 
else
    out = MLRectilinearArrayGrid( ...
        [gridspacing(1) 0 0 0; ...
         0 gridspacing(2) 0 0; ...
         0 0 gridspacing(3) 0; ...
         0 0 0 1], ...
        [N,N,N], ...                    dimensions
        focus, ...                      focus point (z<-0.5 => no focus)
        array(1),array(2), ...          array size (x,y)
        arrayspacing(1), arrayspacing(2), ...              array distance x,y direction
        1.,1.,2., 'cuda');                      % (x-length), s (y-length), k (wavenumber) 
end
pressure = abs(out);

figure(1);


rangex=double(linspace(0,gridspacing(1)*(N-1),N));
rangey=double(linspace(0,gridspacing(2)*(N-1),N));
rangez=double(linspace(0,gridspacing(3)*(N-1),N));
[x,y,z] = meshgrid(rangex, rangey, rangez);


p=patch(isosurface(x,y,z,pressure,iso), 'FaceColor', 'blue', 'EdgeColor', 'none');
isonormals(x,y,z,pressure, p);
p2=patch(isocaps(x,y,z,pressure, iso), 'FaceColor', 'interp', 'EdgeColor', 'none');
lighting phong;
%camlight('headlight');
alpha(0.6);


p2=patch(isosurface(x,y,z,pressure,iso2), 'FaceColor', 'green', 'EdgeColor', 'none');
isonormals(x,y,z,pressure, p);
p22=patch(isocaps(x,y,z,pressure, iso2), 'FaceColor', 'interp', 'EdgeColor', 'none');
lighting phong;
%camlight('headlight');
camlight right
camlight left
view(-30,6);


colormap(jet(256));
colorbar;

% print -depsc -tiff '3dbeam'
