% Create example figure as shown in the paper, shown on his web size
% FNMcirc

f = 1e6;
c = 1500;
lambda = c/f;
%w = f/2./pi;
k = 2*pi*f/c;

sizes = [61 1 101];

radius = 5*lambda; % radius

z = radius^2/lambda/(sizes(3)-1);
y = 0; % ignore
x = radius*(1.5/(sizes(1)-1));

trans = [ x 0 0 0;
          0 y 0 0;
          0 0 z 0;
          0 0 0 1 ]
      

field = MLCircularPistonGrid( trans, sizes, radius, k, 'cuda', 10);

field = reshape( field, sizes(1), sizes(3));

figure(1)
surf( double(abs(field) ) );
figure(2)
imagesc(abs(field)); colorbar; colormap ('default')
figure(3)
imagesc(angle(field)); colorbar; colormap ('HSV')

figure(4);
xp = 0:x:1.5*radius;
zp = 0:z:radius^2/lambda;
mesh(zp, xp, abs(squeeze(double(field)))/max(max(abs(squeeze(double(field))))))
xlabel('axial distance (m)')
ylabel('radial distance (m)')
zlabel('normalized pressure')