clear all;

useCuda = false;
useComputeOnGrid = true;
nbSamplesDustin = 100; % the cuda version currently uses 10 samples only.


c=1500; % speed of sound
f0=1.54e6; % frequency
lambda=c/f0;% wavelength
k=2*pi/lambda; % wave number
u0=1; % surface velocity
rho=1000; % density

a=5*lambda/2; % array element width in azimuth
b=7.5*lambda/2; % array element width in elevation



% compute the C version of the formulas

%if useCuda
%    mex /Users/mario/Uni/BioEng/Code/matlab_src/MLFourElement.cpp -DUSE_CUDA -I/Users/mario/Uni/BioEng/Code/src /Users/mario/Uni/BioEng/Code/build/lib/libFastNearfieldCuda.a /usr/local/cuda/lib/libcuda.dylib /usr/local/cuda/lib/libcudart.dylib 
%    mex /Users/mario/Uni/BioEng/Code/matlab_src/MLFourElementGrid.cpp -DUSE_CUDA -I/Users/mario/Uni/BioEng/Code/src /Users/mario/Uni/BioEng/Code/build/lib/libFastNearfieldCuda.a /usr/local/cuda/lib/libcuda.dylib /usr/local/cuda/lib/libcudart.dylib 
%else
%    mex /Users/mario/Uni/BioEng/Code/matlab_src/MLFourElement.cpp -I/Users/mario/Uni/BioEng/Code/src /Users/mario/Uni/BioEng/Code/build/lib/libFastNearfield.a
%    mex /Users/mario/Uni/BioEng/Code/matlab_src/MLFourElementGrid.cpp -I/Users/mario/Uni/BioEng/Code/src /Users/mario/Uni/BioEng/Code/build/lib/libFastNearfield.a
%end
%mex /Users/mario/Uni/BioEng/Code/src/MLFourElement.cpp /Users/mario/Uni/BioEng/Code/build/libSimBeamLib.a
%mex /Users/mario/Uni/BioEng/Code/src/MLFourElement.cpp
%/Users/mario/Uni/BioEng/Code/build/libSimBeamLib.a 	/usr/local/cuda/lib/libcuda.dylib /usr/local/cuda/lib/libcudart.dylib 
%mex /Users/mario/Uni/BioEng/Code/src/MLFourElement.cpp
%/Users/mario/Uni/BioEng/Code/build/libSimBeamCudaLib.a 	/usr/local/cuda/lib/libcuda.dylib /usr/local/cuda/lib/libcudart.dylib 
%mex /Users/mario/Uni/BioEng/Code/src/MLFourElementGrid.cpp /Users/mario/Uni/BioEng/Code/build/libSimBeamCudaLib.a 	/usr/local/cuda/lib/libcuda.dylib /usr/local/cuda/lib/libcudart.dylib 
%mex /Users/mario/Uni/BioEng/Code/src/MLFourElementGrid.cpp /Users/mario/Uni/BioEng/Code/build/libSimBeamLib.a

%f = 1540000;
%c = 1500;
%k = 2*pi*f/c;
%lambda = c/f;

s = a*2;%5*lambda;
l = b*2;%7.5*lambda;

%siz=[93 1 93]; %[500 1 200];
siz=[61 1 101];
dist=[s/2/(siz(1)-2)/2*3    1   s*s/4/lambda/(siz(3)-2)];


tic
if  not(useComputeOnGrid)
    out = MLRectangularPiston(dist, siz, l, s, k);
else
    trans = [ dist(1) 0 0 0; 0 dist(2) 0 0; 0 0 dist(3) 0; 0 0 0 1 ]
    if( useCuda )
        str = 'cuda';
    else
        str = 'cpu';
    end
    out = MLRectangularPistonGrid(trans, siz, l, s, k, str, 100 );
end
out = double(out);
toc
% out

%tmp=rho*c*c*u0/2/pi; %/7.6624;
tmp=rho*c*u0;
out = tmp * out;
norm = abs(out);

norm2 = reshape(norm, [(siz(1)) (siz(3))]);
% norm2




% compute Dustin's version

% fnm.m

% Fig 2 using McGough's FNM method
% Dustin E. Kruse
% written 8/28/2009

%clear all;

% field plane
%N=92;
Dx=a*1.5;
deltax=Dx/(siz(1)-2);
Dz=a^2/lambda*1;
deltaz=Dz/(siz(3)-2);

m=0:siz(1)-1;
n=0:siz(3)-1;

% [cpx,cpy,cpz]=meshgrid(m*deltax,0,n*deltaz);
[cpx,cpy,cpz]=meshgrid(m*dist(1),0,n*dist(3));
cp=[cpx(:),cpy(:),cpz(:)];

pect=[0;0;0].';

p=complex(zeros(size(pect,1),size(cp,1)),zeros(size(pect,1),size(cp,1)));

% find Gauss abscissas and weights
[xx,ww]=gaussquad(nbSamplesDustin,-1,1);
xx=xx(:).';
ww=ww(:).';

tic
% fnm method for rectangular elements
tmp=-complex(0,1)*rho*c*u0/2/pi;
%tic;
for j=1:size(pect,1),
    points=cp;

    %tic;
    for i=1:size(points,1),

        x=points(i,1);
        y=points(i,2);
        z=points(i,3);

        s1=a-x;
        l1=b-y;
        s2=a+x;
        l2=b+y;

        if( false)
            bb=l2;
            aa=-l1;
            xx2=(bb-aa)/2*xx+(aa+bb)/2;
            ww2=(bb-aa)/2*ww;
            xsq=xx2.^2;
            
            term1=s1.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+s1.^2))-exp(-complex(0,1)*k*z))./(xsq+s1.^2));
            term3=s2.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+s2.^2))-exp(-complex(0,1)*k*z))./(xsq+s2.^2));

            bb=s2;
            aa=-s1;
            xx2=(bb-aa)/2*xx+(aa+bb)/2;
            ww2=(bb-aa)/2*ww;
            xsq=xx2.^2;
            term2=l1.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+l1.^2))-exp(-complex(0,1)*k*z))./(xsq+l1.^2));
            term4=l2.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+l2.^2))-exp(-complex(0,1)*k*z))./(xsq+l2.^2));

        else
            bb=l2;
            aa=-l1;
            xx2=(bb-aa)/2*xx+(aa+bb)/2;
            ww2=(bb-aa)/2*ww;
            xsq=xx2.^2;
            term1=s1.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+s1.^2))-exp(-complex(0,1)*k*z))./(xsq+s1.^2));
            
            bb=s2;
            aa=-s1;
            xx2=(bb-aa)/2*xx+(aa+bb)/2;
            ww2=(bb-aa)/2*ww;
            xsq=xx2.^2;
            term2=l1.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+l1.^2))-exp(-complex(0,1)*k*z))./(xsq+l1.^2));

            bb=l2;
            aa=-l1;
            xx2=(bb-aa)/2*xx+(aa+bb)/2;
            ww2=(bb-aa)/2*ww;
            xsq=xx2.^2;
            term3=s2.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+s2.^2))-exp(-complex(0,1)*k*z))./(xsq+s2.^2));

            bb=s2;
            aa=-s1;
            xx2=(bb-aa)/2*xx+(aa+bb)/2;
            ww2=(bb-aa)/2*ww;
            xsq=xx2.^2;
            term4=l2.*sum(ww2.*(exp(-complex(0,1)*k*sqrt(z^2+xsq+l2.^2))-exp(-complex(0,1)*k*z))./(xsq+l2.^2));
        end
        
        p(j,i)=tmp*(term1+term2+term3+term4);
        % disp(num2str(i))
    end
   % toc;
end
toc
p2=reshape(p,size(squeeze(cpx)));



% done computing

figure(1)

subplot(2,2,1);
surf(norm2);
axis tight;
title( str );

subplot(2,2,2);%surf(n*deltaz/(a^2/lambda),m*deltax/a,abs(p2)/max(max(abs(p2))))
surf(abs(p2))
axis tight
title( 'Matlab Reference' );
%colormap(gray(256))


% abs error

normDustin = abs(p2);
abserror = norm2 - normDustin;
subplot(2,2,4);
surf(abserror); axis tight;
title( 'abolute error' );


% rel error

relerror = abserror ./ abs(p2);
subplot(2,2,3);
surf(relerror);
axis tight;
title( 'relative error' );
%axis([0 93 0 93 -1 1])



% print graphics to file
%figure(1); print 'comparison1.eps'
%figure(2); print 'comparison2.eps'
%figure(3); print 'comparison3.eps'
%figure(4); print 'comparison4.eps'
