clear all;

file = open('../../matlab/Data/ref_fnm_200.mat')
pref_ref = file.pref_ref;
clear file;

f = 1000000; % 1540000;
c = 1500;
k = 2*pi*f/c;
lambda = c/f;
rho = 1000;

s = 5*lambda;
l = 7.5*lambda;

siz=[61 1 101];

dist=[s/2/siz(1)/2*3    1   s*s/4/lambda/siz(3)];
transform = [ dist(1) 0 0 0; 0 dist(2) 0 0; 0 0 dist(3) 0; 0 0 0 1];
transform = transpose(transform)

res=200;


%pref_ref = -1j*c*rho*MLRectangularPistonGrid(transform, siz, l, s, k, 'cuda',256);

out1 = -1j*c*rho*MLRayleighSommerfeldGrid(transform, siz, l, s, k, 'cuda', [res res]);
%out1 = -1j*c*rho*MLRayleighSommerfeldGrid(transform, siz, l, s, k, 'cuda', [-res res]);

pref_ref = squeeze(pref_ref);
out1 = squeeze(out1);

% set the first line to zero as RS is not well-defined there
% and usually explodes due to a division by zero
pref_ref(:,1) = 0;
out1(:,1) = 0;

figure(1); paperfont;
surf(squeeze(abs(out1)));
%imagesc(angle(squeeze(out1)));
title('Rayleigh-Sommerfeld');
axis tight;

figure(2); paperfont;
surf(squeeze(abs(pref_ref)));
%imagesc(angle(pref_ref));
title('FNM 200 reference');
%surf(squeeze(abs(out2)));
axis tight;


figure(3); paperfont;
surf(abs( squeeze(out1)) - abs(pref_ref));
title('difference of abs')
axis tight;

figure(4); paperfont;
imagesc(angle(squeeze(out1)) - angle(pref_ref));
title('angular difference');

figure(5); paperfont;
imagesc(real(squeeze(out1)) - real(pref_ref));
title('real difference'); colorbar;

figure(6); paperfont;
imagesc(imag(squeeze(out1)) - imag(pref_ref));
title('imag difference'); colorbar;

figure(7); paperfont;
surf( (abs( out1 - pref_ref))/(max(max(abs(pref_ref)))));
title('normalized absolute error')
axis tight;

err = max(max(abs(out1-pref_ref)))/max(max(abs(pref_ref)))
