% code to save a matrix as a regularly spaced vtk data set
%

function SaveVTK(img, binary, filename)

    tic
    fwid = fopen(filename, 'w','b');

    fprintf(fwid, '# vtk version 2.0\n');
    fprintf(fwid, 'MatlabMatrix\n');

    if(binary)
        fprintf(fwid, 'BINARY\n');
    else
        fprintf(fwid, 'ASCII\n');
    end

    fprintf(fwid, 'DATASET STRUCTURED_POINTS\n');
    fprintf(fwid, 'DIMENSIONS %d %d %d\n', size(img,1), size(img,2), size(img,3));
    fprintf(fwid, 'ORIGIN 0 0 0\n');
    fprintf(fwid, 'SPACING 1 1 1\n');
    fprintf(fwid, 'POINT_DATA %d\n', prod(size(img)));
    fprintf(fwid, 'SCALARS data float\n');
    fprintf(fwid, 'LOOKUP_TABLE default\n');

    if(binary)
        fwrite(fwid, img, 'float32')
    else
        fprintf(fwid, '%g\n', img)
    end

    fclose(fwid);
    fprintf(1, 'done in %5.3f s\n', toc);

