
clear all;

D=0.09

f0=1e6;

define_media;

a = 200; %0.09; %size(fig3_pressure,1);
width = 0.09; % 9cm
halfwidth = width/2;
delta = width/a;

Nn=uint32(floor(D/delta));
N = double(Nn)

rho = 1000;
c=1500;

lambda = lossless.soundspeed/f0;
k=2*pi/lambda;
dk = 2*pi/(N*delta);

z=lambda; %5*delta;


Hu=zeros(N,N);
hu=zeros(N,N);


% compute Hu
for m=1:N

    kx = -pi/delta + dk*m-dk;
    for n=1:N
        ky = -pi/delta + dk*n;

        kxy = kx^2 + ky^2;
        % why is this faster than...
        if(abs(kx^2 + ky^2 - k^2 ) < 1e-3)
            Hu(m,n)=complex(0,0);
        else
            if(kxy <= k^2)
                t1 = sqrt(k^2 - kxy);
                Hu(m,n) = exp(complex(0.,-z*t1))/complex(0,t1);
            else
                t1 = sqrt(kxy - k^2);
                Hu(m,n) = complex(exp(-z*t1)/t1,0.0);
            end
        
            
        %... this?
        %t1 = sqrt(kx^2 + ky^2 - k^2);
        %Hu(m,n) = exp(-t1*z)/t1;
        %Hu(m,n) = exp(-z*sqrt((kx^2 + ky^2 - k^2)))/sqrt((kx^2 + ky^2 - k^2));

        end
    end

    %Hu(m,:) = exp(-z*sqrt(ky_a.^2 + (kx^2 - k2)))./sqrt(ky_a.^2 + (kx^2 - k2));
end
Hu_spectral = fftshift(fftshift(Hu,1),2)*k*rho;


Hu=zeros(N,N);
hu=zeros(N,N);

% compute hu and its FFT
for i=1:N
    % disp(i)
    x = (-N/2 + i)*delta;
    for j=1:N
        y = (-N/2 + j)*delta;
        r = sqrt(x^2 + y^2 + z^2);
        hu(i,j) = exp(-1j*k*r)/(2*pi*r);
    end
end
Hu_spatial = fft2(fftshift(fftshift(hu,1),2));


Hu=zeros(N,N);
hu=zeros(N,N);

% hu C++ spatial
for m=1:N
    x = (-N/2 + m)*delta;
    for n=1:N
        y = (-N/2 + n)*delta;
        hu(m,n) = MLAngularSpectrumHuSpatial( [x,y,z], k );
    end
end
Hu_c_spatial = fft2(fftshift(fftshift(hu,1),2));


Hu=zeros(N,N);
hu=zeros(N,N);

% hu C++ spectral
for m=1:N
    kx = -pi/delta + dk*m - dk;
    for n=1:N
        ky = -pi/delta + dk*n;

        Hu(m,n) = MLAngularSpectrumHu([kx, ky], z, k);
    end
    Hu_c_spectral = fftshift(fftshift(Hu,1),2)*k*rho;
end


scale = max(max(abs(Hu_spatial)));

figure(1); 
subplot(1,2,1); paperfont;
imagesc(abs(Hu_spectral)); title('Hu spectral'); colorbar
subplot(1,2,2); paperfont;
imagesc(abs(ifft2(Hu_spectral)));colorbar



figure(2); 
subplot(1,2,1); paperfont;
imagesc(abs(Hu_c_spectral));title('Hu C++ spectral'); colorbar
subplot(1,2,2); paperfont;
imagesc(abs(ifft2(Hu_c_spectral)));colorbar


figure(3);
subplot(1,2,1); paperfont;
imagesc(abs(Hu_spatial)); title('Hu spatial'); colorbar
subplot(1,2,2); paperfont;
imagesc(abs(ifft2(Hu_spatial)));colorbar



figure(4); 
subplot(1,2,1); paperfont;
imagesc(abs(Hu_c_spatial));title('Hu C++ spatial');colorbar
subplot(1,2,2); paperfont;
imagesc(abs(ifft2(Hu_c_spatial)));colorbar



figure(5);
subplot(1,2,1); paperfont;
imagesc(abs(Hu_c_spectral-Hu_spectral));colorbar
title('Hu_c_spec - Hu_spec')
subplot(1,2,2); paperfont;
imagesc(abs(Hu_c_spatial-Hu_spatial));colorbar
title('Hu_c_spat - Hu_spat')

figure(6); title('Hu_c_spec - Hu_spec')
subplot(1,2,1); paperfont;
imagesc(abs(Hu_c_spatial-Hu_c_spectral));colorbar
subplot(1,2,2); paperfont;
imagesc(abs(Hu_spatial-Hu_spectral));colorbar

