
clear all;


%restriction = 'n'
restriction = 'a'   % somehow, the filter is too much a low-pass, has to be checked!



D=0.09

f0=1e6;

define_media;

a = 200; %size(fig3_pressure,1);
width = 0.09; % 9cm
halfwidth = width/2;
delta = width/a;

Nn=uint32(floor(D/delta));
N = double(Nn)

rho = 1000;
c=1500;

lambda = lossless.soundspeed/f0;
k=2*pi/lambda;
dk = 2*pi/(N*delta);

z=lambda; %5*delta;


Hu=zeros(N,N);
hu=zeros(N,N);


kc2 = k^2*((D^2)/2/((D^2)/2+z^2));

% compute Hu
for m=1:N

    kx = -pi/delta + dk*m-dk;
    for n=1:N
        ky = -pi/delta + dk*n;

        kxy = kx^2 + ky^2;
        % why is this faster than...
        if(abs(kx^2 + ky^2 - k^2 ) < 1e-3)
            Hu(m,n)=complex(0,0);
        else
            if(kxy <= k^2)
                t1 = sqrt(k^2 - kxy);
                Hu(m,n) = exp(complex(0.,-z*t1))/complex(0,t1);
            else
                t1 = sqrt(kxy - k^2);
                Hu(m,n) = complex(exp(-z*t1)/t1,0.0);
            end
        
            
        %... this?
        %t1 = sqrt(kx^2 + ky^2 - k^2);
        %Hu(m,n) = exp(-t1*z)/t1;
        %Hu(m,n) = exp(-z*sqrt((kx^2 + ky^2 - k^2)))/sqrt((kx^2 + ky^2 - k^2));

        end
        

        if(restriction == 'a')
            if(kx^2 + ky^2 > kc2)
                Hu(m,n) = 0;
            end
        end
    end

    %Hu(m,:) = exp(-z*sqrt(ky_a.^2 + (kx^2 - k2)))./sqrt(ky_a.^2 + (kx^2 - k2));
end
Hu_spectral = fftshift(fftshift(Hu,1),2)*k*rho;
Hu_spatial  = ifft(Hu_spectral);



surf(abs(Hu_spatial));

