clear all

define_media;

f0=1e6;
c=lossless.soundspeed;
lambda=c/f0;
k=2*pi/lambda;
rho=lossless.density;
 
s = 5.0*lambda;
l = 7.5*lambda;
 
hw=s/2;
hh=l/2;
 
Transducer=get_rect(hw,hh,[0 0 0],[0 0 0]);
 
siz=[61 1 101]; % same plot as McGough

dist=[s/2/(siz(1)-1)/2*3    1   s*s/4/lambda/(siz(3)-1)];
% dist=[s/2/(siz(1)-1)/2*3    1   1];

x=0:dist(1):1.5*hw;
z=0:dist(3):hw^2/lambda;
% z=0;

ps=set_coordinate_grid(dist,x(1),x(end),0,0,z(1),z(end));

pref_ref=squeeze(fnm_call(Transducer,ps,lossless,200,f0,0));
tmp=max(max(abs(pref_ref)));

transform = [ dist(1) 0 0 0; 0 dist(2) 0 0; 0 0 dist(3) 0; 0 0 0 1].';

ind=1;
for i=2:2:100,
    pref_fnm_focus=squeeze(fnm_call(Transducer,ps,lossless,i,f0,0));
    pref_fnm_dustin=j*rho*c*squeeze(DustinRectangularPistonGrid2( single(transform), single(siz), single(l), single(s), single(k), i ));
    
    error_fnm_focus(ind)=max(max(abs(pref_fnm_focus-pref_ref)))/tmp;
    error_fnm_dustin(ind)=max(max(abs(pref_fnm_dustin-pref_ref)))/tmp;
    
    disp(num2str(i))
    ind=ind+1;
end

figure;
semilogy(2:2:100,error_fnm_focus,'b','LineWidth',2);hold on
semilogy(2:2:100,error_fnm_dustin,'g--','LineWidth',2);hold off
axis([0 100 1e-15 1e5]);grid on;

figure;surf(z,x,abs(pref_ref));view(-120,40)
figure;surf(z,x,abs(pref_fnm_dustin));view(-120,40)
figure;surf(z,x,abs(pref_fnm_focus));view(-120,40)
figure;surf(z,x,abs(pref_fnm_dustin-pref_fnm_focus)/tmp);view(-120,40)
