clear all

f0=1e6;
define_media;
lambda=0.0015;
 
s = 5.0*lambda;
l = 7.5*lambda;
 
hw=s/2;
hh=l/2;
 
Transducer=get_rect(s/2,l/2,[0 0 0],[0 0 0]);
 
siz=[61 1 101]; % same plot as McGough
dist=[s/2/(siz(1)-1)/2*3    1   s*s/4/lambda/(siz(3)-1)];
% dist=[s/2/(siz(1))/2*3    1   s*s/4/lambda/(siz(3))];

x=0:dist(1):1.5*hw;
z=0:dist(3):hw^2/lambda;
 
ps=set_coordinate_grid(dist,0,x(end),0,0,0,z(end));

% refpref=squeeze(fnm_call_gpu(Transducer,ps,lossless,200,f0,0));
refpref_gpu=squeeze(fnm_call(Transducer,ps,lossless,200,f0,0));
refpref_focus=refpref_gpu;

tmp_gpu=max(max(abs(refpref_gpu)));
tmp_focus=max(max(abs(refpref_focus)));

ind=1;
for i=2:2:128,
    pref_gpu=j*1.5e6*squeeze(fnm_call_gpu(Transducer,ps,lossless,i,f0,0));
    pref_focus=squeeze(fnm_call(Transducer,ps,lossless,i,f0,0));

    error_gpu(ind)=max(max(abs(pref_gpu-refpref_gpu)))/tmp_gpu;
    error_gpu2(ind)=max(max(abs(pref_gpu(:,4:end)-refpref_gpu(:,4:end))))/tmp_gpu;
    error_gpu3(ind)=max(max(abs(pref_gpu(:,6:end)-refpref_gpu(:,6:end))))/tmp_gpu;
    error_focus(ind)=max(max(abs(pref_focus-refpref_focus)))/tmp_focus;
    
    disp(num2str(i))
    ind=ind+1;
end

figure;semilogy(2:2:128,error_gpu,'g');hold on
semilogy(2:2:128,error_gpu2,'m')
semilogy(2:2:128,error_gpu3,'r')
semilogy(2:2:128,error_focus,'b');hold off

mean(mean(abs(refpref_focus)./abs(pref_gpu)))
max(max(abs(refpref_focus)./abs(pref_gpu)))

% f0=1e6;
% define_media;
% lambda=0.0015;
%  
% s = 5.0*lambda;
% l = 7.5*lambda;
%  
% hw=s/2;
% hh=l/2;
%  
% Transducer=get_rect(s/2,l/2,[0 0 0],[0 0 0]);
%  
% siz=[61 1 101]; % same plot as McGough
% dist=[s/2/(siz(1)-1)/2*3    1   s*s/4/lambda/(siz(3)-1)];
%  
% x=0:dist(1):1.5*hw;
% z=0:dist(3):hw^2/lambda;
%  
% ps=set_coordinate_grid(dist,0,x(end),0,0,0,z(end));
%  
% refpref=squeeze(fnm_call(Transducer,ps,lossless,200,f0,0));
% tmp=max(max(abs(refpref)));
% 
% for i=1:100,
% pref=squeeze(fnm_call(Transducer,ps,lossless,i,f0,0));
% error(i)=max(max(abs(pref-refpref)))/tmp;
% disp(num2str(i))
% end
% 
% figure;semilogy(1:100,error)
% 


% f = 1e6;
% c = 1500;
% lambda = c/f;
% k = 2*pi/lambda;
% 
% s = 5*lambda;
% l = 7.5*lambda;
% 
% siz=[61 1 101]; % same plot as McGough
% dist=[s/2/(siz(1)-1)/2*3    1   s*s/4/lambda/(siz(3)-1)];
% transform = [ dist(1) 0 0 0; 0 dist(2) 0 0; 0 0 dist(3) 0; 0 0 0 1];
% transform = transpose(transform)
% 
% pref = squeeze(MLRectangularPistonGrid(transform, siz, l, s, k, 'cuda', 100));
% pref2 = squeeze(fnm_call_gpu(Transducer,ps,lossless,100,f0,0));

