% compute a 3D image of a beam using the fast nearfield method for
% 2D arrays
%
%clear all;



c=1500;         % speed of sound
f0=1.50e6;      % frequency
lambda=c/f0;    % wavelength
k=2*pi/lambda;  % wave number
u0=1;           % surface velocity
rho=1000;       % density

kerf = 200e-6;

if true
    %a=0.5*(3*lambda-kerf); % array element half width in azimuth
    %b=0.5*(3*lambda-kerf); % array element half width in elevation
    a = 0.5*(3*lambda - lambda/5);
    b = a;
else
    a=0.5*(lambda/2);
    b=0.5*(lambda/2);
end

s = a*2;        % piston size
l = b*2;        % piston size

E = 16;          % nb of elements in each direction
if true
    eldist = [3*lambda 3*lambda]; % center-to-center spacing of elements
else
    eldist = [lambda/2 lambda/2];
end
%focus = [ 0 0 eldist(1)*(E-1) ]; % focal point one array size away at the center



% eldist(1)*(E-1)*0.5

%dist=[lambda/4 lambda/4 lambda/2];
dist=[lambda/2 lambda/2 lambda/2];
%siz=[192 192 192]; % grid size, currently must match eldist/dist
siz=[192 192 256];

tic
offx = (-0.5*siz(1)*dist(1));
offy = (-0.5*siz(2)*dist(2));
trans = [ dist(1) 0 0 0; 0 dist(2) 0 0; 0 0 dist(3) 0; offx offy 0 1 ]


%focus = [ 192/2 99 80 1] * trans
%focus = [ 192/2 103 40 1] * trans
%focus = [0 0 2*eldist(2)*(E-1)]; % first picture
%focus = [0 0 1.5*eldist(2)*(E-1)]; % second picture
%focus = [0 0 1.2*eldist(2)*(E-1)]; % third picture
%focus = [ 0  0  2.0*eldist(1)*(E)]; % fourth picture
focus = [ 2*lambda 0 16*3*lambda];

load('/Users/mario/Desktop/Dump/complex_weights.mat'); 
phaseterm = complex_weights;
%loaded = reshape(phaseterm, E, E);
%focus = reshape(focus, E, E);
%focus = -conj(focus);
%focus = ones(E, E);
%focus = fliplr(flipud(focus));

%focus = ones(E,E);
%focus = zeros(E,E);
%focus(4, 4) = complex(1,0);
%focus(4, 5) = complex(1,0);
%focus(5, 4) = complex(1,0);
%focus(5, 5) = complex(0,1);

if false
    phaseterm = zeros(E,E);
    if(false)
        for i=1:E
            ex = 0;
            ey = (i-1-0.5*(E-1)) * eldist(1);
            %if (1==i)
                phaseterm(i, 4) = exp(complex(0,1) *k* (sqrt((ex-focus(1))^2 + (ey-focus(2))^2 + focus(3)^2)));
            %end
        end
    end

    if true
        centerdist = norm(focus(1:3));

        phaseterm = zeros(E,E);
        for i=1:E
            for j=1:E
                ex = (j-1-0.5*(E-1)) * eldist(1);
                ey = (i-1-0.5*(E-1)) * eldist(2);
                phaseterm(i,j) = exp( -complex(0., 1) * k * (sqrt((ex-focus(1))^2 + (ey-focus(2))^2 + focus(3)^2)-centerdist));
            end
        end
    end
end

if (true)
    if(false) % single focal point
        tic
        xmin = -eldist(1) * (E-1)*0.5;
        ymin = -eldist(2) * (E-1)*0.5;

        shiftx =  xmin + focus(1);
        shifty =  ymin + focus(2);
        shiftz =  focus(3);
        phase_trans = [ eldist(1) 0 0 0; 0 eldist(2) 0 0; 0 0 0 0; shiftx shifty shiftz 1]
        out = MLRectangularPistonGrid(phase_trans, [ E, E, 1 ], l, s, k);
        %phaseterm = 1*exp(1*angle(phaseterm)*1j)
        phaseterm = phaseterm./abs(phaseterm);
        toc
    else % multiple focal points
        foci = [ focus(1) focus(2) focus(3); +focus(1) focus(2) focus(3) ];
        Npoints = size(foci,1);
        p = ones(Npoints,1)*5e6;
        %Hmtx = complex(zeros(1, E*E));
        
        xmin = -eldist(1) * (E-1)*0.5;
        ymin = -eldist(2) * (E-1)*0.5;
        
        for im = 1:Npoints
            focus = foci(im,:);
            shiftx =  xmin + focus(1);
            shifty =  ymin + focus(2);
            shiftz =  focus(3);
            phase_trans = [ eldist(1) 0 0 0; 0 eldist(2) 0 0; 0 0 0 0; shiftx shifty shiftz 1];
            
            % Hmtx(im,:) =
            a = reshape(MLRectangularPistonGrid(phase_trans, [ E, E, 1 ], l, s, k), 1, E*E );
            Hmtx(im,:) = a;
        end
        Hmtx;
        max(max(abs(Hmtx)));
        
        Hmtx_norm = Hmtx;
        H = Hmtx_norm;
        tmpH = H*H';
        excitation = H'*inv(tmpH)*p;
        pw = inv(tmpH)*p;
        H*excitation;
        phaseterm = excitation;
    end
end
% return;
% focus = ones(E,E);
focus = phaseterm;
% focus = complex_weights;
focus
out = MLRectilinearArrayGrid(trans, siz, focus, E, E, eldist(1), eldist(2), l, s, k);
toc



%tmp=rho*c*c*u0/2/pi; %/7.6624;
tmp=1. %rho*c*u0;
out = tmp * out;
normalized = abs(out);

%normalized2 = reshape(normalized, [(siz(1)) (siz(3))]);
% normalized2

%figure; surf(normalized2);
%axis tight;

figure;
isosurface(normalized/max(max(max(normalized))), 0.5);

figure;
plane = reshape(normalized(:,103,:), size(normalized, 1), size(normalized,3));
%surf(abs(plane));
imagesc(abs(plane));
return


if 0
%figure;
% generate 0.2 degree isosurface
[x0, y0, z0] = meshgrid(1:siz(1), 1:siz(2), 1:siz(3));
figure;
%iso = 1000000;
iso =  20000;
p=patch(isosurface(x0,y0,z0,normalized,iso));
p2=patch(isocaps(x0,y0,z0,normalized,iso),'FaceColor','interp','EdgeColor','none');
isonormalizedals(x0,y0,z0,normalized,p);
colormap(jet(256))
colorbar

set(p,'FaceColor','red','EdgeColor','none');
%daspect([1 1 1]);
%view(-107,-18);
%view(-61,8);
camlight headlight;
camlight;
lighting gouraud;
%axis([-25 25 -25 25 -25 25]);
box on
end