%
% test angular spectrum approach
%
%


% compute initial grid (2D plane)
f0=1.5e6;
c=1500;
k=2*pi/(c/f0);

N=128;
D=100/1000;
a=1;
delta=D/(N-1);





siz=[N N 1];

if 1
    phi=0;
    m=(-N/2+1+phi):(N/2+phi);
    n=(-N/2+1+phi):(N/2+phi);
    x=m*delta;
    y=n*delta;

    dk=2*pi/(N*delta);
    kx=m*dk;
    ky=n*dk;
    [kx,ky]=meshgrid(kx,ky);



    ind1=find((kx.^2+ky.^2)<=k^2);
    ind2=find((kx.^2+ky.^2)>k^2);

    k2=single(k);
    kx=single(kx);
    ky=single(ky);

    plane=(zeros(N,N));

    ind3=find((kx.^2+ky.^2)<40000.);
    %ind3=find((kx.^2+ky.^2)<200000.);
    %ind3=find((kx.^2+ky.^2)<1000.);

    plane(ind3)=1.;
    
    plane=fftshift(fftshift(plane,2),1);

    figure(1);
    imagesc(abs(plane));%pause(1.0);
else
    delta = 1; %lambda/2; %0.001;
    dist=[delta delta delta]; %s/2/(siz(1)-2)/2*3    s/2/(siz(2))   s*s/4/lambda/(siz(3)-2)]*2.0;

    z0 = delta;
    l = 1;%k/2*10;
    s = 1;%k/4*10;

    trans = [ dist(1) 0 0 -0.5*siz(1)*dist(1); 0 dist(2) 0 -0.5*siz(2)*dist(2); 0 0 dist(3) z0; 0 0 0 1 ];
    trans = transpose(trans);
  
    plane = MLRectangularPistonGrid(trans, siz, l, s, 0.001);

    plane = plane(:,:,1);   % remove 3rd dimension

    plane = plane.*1000;

    figure(2);
    imagesc(abs(plane));
    
    %plane = fftshift(fftshift(plane, 1),2);    
    %plane = ifft2(plane).*1000000.;
end

figure(1);
imagesc(log(abs(plane)));
% figure(2); imshow(angle(plane));

tic
Z = 128;
field3d = MLAngularSpectrumApproach( plane, [siz(1) siz(2) Z], [delta delta 1/300], k, 'mHp');
toc

%for z=1:Z
%    figure(3); imagesc( log(abs(field3d(:,:,z))));
%    %figure(4); imagesc( angle(field3d(:,:,z)));
%   pause(1.5)
%end
figure(2)
imagesc( abs(field3d(:,:,1)));
figure(3)
isosurface( abs(field3d), 0.00001*N*N);