%
% test angular spectrum approach vs. FastNearfieldMethos
%
%

iso=400000

% compute initial grid (2D plane)
f0=1.54e6;
c=1500;
lambda=c/f0;
k=2*pi/lambda;

N=128;%+64;
D=10*k;
delta=lambda/2; %D/(N-1);

u0 = 1;
rho = 1000;

siz=[N N 32];

reference_slice_idx = 1;


dist=[delta delta delta]; %s/2/(siz(1)-2)/2*3    s/2/(siz(2))   s*s/4/lambda/(siz(3)-2)]*2.0;

z0 = dist(3);
%l = 1;%k/2*10;
%s = 1;%k/4*10;
a=5*lambda/2/10;
b=7.5*lambda/2/10;
s= a*2;
l= b*2;


trans = [ dist(1) 0 0 -0.5*siz(1)*dist(1); 0 dist(2) 0 -0.5*siz(2)*dist(2); 0 0 dist(3) z0; 0 0 0 1 ];
trans = transpose(trans);

tic;
fastnearfield3d = MLFourElementGrid(trans, siz, l, s, k);
toc
fastnearfield3d = fastnearfield3d * rho*c*u0;

if size(fastnearfield3d,3) > 1
    figure(1); isosurface(abs(fastnearfield3d), iso);
    plane = fastnearfield3d(:,:,reference_slice_idx);   % remove 3rd dimension
else
    plane = fastnearfield3d(:,:);
end



figure(2);
imagesc(abs(plane));

% filter the mask to avoid artifacts on the boundary.
% 4 or 5 seem to be good choices here.
if 0
    %plane(1:N/4, 1:N) = 0;
    %plane(N-N/4:N, 1:N) = 0;
    %plane(1:N, 1:N/4) = 0;
    %plane(1:N, N-N/4+1:N) = 0;
    mask = gausswin(N,6) * transpose(gausswin(N,5));
    plane = plane .* mask;
    figure(6);
    imagesc(abs(plane));
end

%planefft = fft2(plane);

padding = N; % padding on each side

newsiz = [siz(1)+2*padding  siz(2)+2*padding  siz(3)];

nplane = zeros(newsiz(1));
nplane(padding+1:padding+N, padding+1:padding+N) = plane;


%figure(3);
%imagesc(log(abs(planefft)));
%imagesc(abs(planefft));
% figure(2); imshow(angle(plane));

nplane = fft2(nplane);

tic
Z = siz(3);
field3d = MLAngularSpectrumApproach( nplane, [newsiz(1) newsiz(2) Z], dist, k, 'mHp');
toc

%field3fourier is planefft stored by the ASA code for debugging
figure(3);
%imagesc(log(abs(field3fourier)));
imagesc(abs(field3fourier));


%for z=1:Z
%    figure(3); imagesc( log(abs(field3d(:,:,z))));
%    %figure(4); imagesc( angle(field3d(:,:,z)));
%   pause(1.5)
%end
figure(4)
imagesc( log(abs(field3d(:,:,1))));

% remove padding
field3d_c = field3d(padding+1:padding+N, padding+1:padding+N, 1:siz(3));

% how can I explain this scaling factor?
scaling = (N/(N+2*padding))^2 * 1/2; % which equals N^2/(2*(N+2*padding))^2

field3d_c(:,:, reference_slice_idx+1:siz(3)) = field3d_c(:,:, 1:siz(3)-reference_slice_idx) * scaling;
field3d_c(:,:, 1:reference_slice_idx) = fastnearfield3d(:,:, 1:reference_slice_idx);

figure(5)
isosurface( abs(field3d_c), iso);

cut = field3d_c(50:80,50:80,:);
