%
% test angular spectrum approach vs. FastNearfieldMethos
%
%

iso=400000

% compute initial grid (2D plane)
f0=1.5e6;
dx=0.5e-3;
dy=0.5e-3;
dz=0.5e-3;
delta=[dx dy dz];
L = 0.05; % m
z0 = 0.01


trans = [ dx 0 0 -L; 0 dy 0 -L; 0 0 dz z0; 0 0 0 1 ];
trans = transpose(trans);

a=0.003; %m ???

c=1500;
lambda=c/f0;
k=2.*pi/lambda;

%N=128;%+64;
%D=10*k;

%u0 = 1;
%rho = 1000;




N = 201;
Z=100
siz=[N N Z];
reference_slice_idx = 1;




tic;
fastnearfield3d = MLRectangularPistonGrid(trans, siz, a, a, k);
%fastnearfield3d = MLCircularPistonGrid(trans, siz, a, k, 'cuda');
toc
%fastnearfield3d = fastnearfield3d * rho*c*u0;

%figure(1); isosurface(abs(fastnearfield3d), iso);

plane = fastnearfield3d(:,:,reference_slice_idx);   % remove 3rd dimension

figure(2);
imagesc(abs(plane));colorbar
figure(4);
imagesc(angle(plane));colorbar

figure(3);
imagesc(abs( fftshift(fftshift( fft2(plane),1),2)))

% filter the mask to avoid artifacts on the boundary.
% 4 or 5 seem to be good choices here.
if 0
    %plane(1:N/4, 1:N) = 0;
    %plane(N-N/4:N, 1:N) = 0;
    %plane(1:N, 1:N/4) = 0;
    %plane(1:N, N-N/4+1:N) = 0;
    mask = gausswin(N,6) * transpose(gausswin(N,5));
    plane = plane .* mask;
    figure(6);
    imagesc(abs(plane));
end

%planefft = fft2(plane);

padding = N; % padding on each side

newsiz = [siz(1)+2*padding  siz(2)+2*padding  siz(3)];

nplane = zeros(newsiz(1));
nplane(padding+1:padding+N, padding+1:padding+N) = plane;


%figure(3);
%imagesc(log(abs(planefft)));
%imagesc(abs(planefft));
% figure(2); imshow(angle(plane));

nplane = fft2(nplane);

tic
Z = siz(3);
%field3d = MLAngularSpectrumApproach( nplane, [newsiz(1) newsiz(2) z], dist, k, 'mHp');
p0_asa = MLAngularSpectrumApproach(nplane, [size(nplane,1), size(nplane,2), Z], [dx, dy, dz], k, 'mHp');
toc

%field3fourier is planefft stored by the ASA code for debugging
%figure(3);
%imagesc(log(abs(field3fourier)));
%imagesc(abs(field3fourier));


%for z=1:Z
%    figure(3); imagesc( log(abs(field3d(:,:,z))));
%    %figure(4); imagesc( angle(field3d(:,:,z)));
%   pause(1.5)
%end
%figure(4)
%imagesc( log(abs(field3d(:,:,1))));

% remove padding
%field3d_c = field3d(padding+1:padding+N, padding+1:padding+N, 1:siz(3));
p0_asa_ = p0_asa(padding+1:padding+N, padding+1:padding+N, 1:siz(3));


% how can I explain this scaling factor?
%scaling = (N/(N+2*padding))^2 * 1/2; % which equals N^2/(2*(N+2*padding))^2

%field3d_c(:,:, reference_slice_idx+1:siz(3)) = field3d_c(:,:, 1:siz(3)-reference_slice_idx);% * scaling;
%field3d_c(:,:, 1:reference_slice_idx) = fastnearfield3d(:,:, 1:reference_slice_idx);

%figure(5)
%isosurface( abs(field3d_c), iso);

%cut = field3d_c(50:80,50:80,:);
